config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Reveal health status on /up that returns 200 if the app boots with no exceptions, otherwise 500.
  # Can be used by load balancers and uptime monitors to verify that the app is live.
  get "up" => "rails/health#show", as: :rails_health_check

  # Render dynamic PWA files from app/views/pwa/* (remember to link manifest in application.html.erb)
  # get "manifest" => "rails/pwa#manifest", as: :pwa_manifest
  # get "service-worker" => "rails/pwa#service_worker", as: :pwa_service_worker

  # Defines the root path route ("/")
  # root "posts#index"
  scope module: "oni_sorceress" do
    get "allfeed.atom" => "outer_comm/atom#index", as: :allfeed_atom, format: false
    get "robots.txt" => "outer_comm/robots_txt#show", as: :robots_txt, format: false
    get "sitemap.xml" => "outer_comm/sitemap_xml#show", as: :sitemap_xml, format: false

    scope module: "front" do
      get "browse", to: "browse_by_category#index"
      get "categories/:first_level", to: "first_level_category#show", as: "first_level_category"
      get "categories/:first_level/:second_level", to: "second_level_category#show", as: "second_level_category"

      resources :articles, only: [:index, :show] do
        resources :comments, only: :create
      end
      resources :authors, only: :show

      root to: "beginnings#index"
    end

    scope module: "web_services" do
      resource :what_is_my_ip_address, only: :show
    end

    namespace "administration" do
      resources :style_guide, only: :index, if: -> { Rails.env.development? } do
        collection do
          get :articles
          get :articles_mobile
        end
      end

      namespace :moderation do
        resources :comments, only: [:index]
      end
    end
  end
end

app/controllers/oni_sorceress/outer_comm.rb
# frozen_string_literal: true

module ::OniSorceress::OuterComm
end

app/controllers/oni_sorceress/outer_comm/atom_controller.rb
# frozen_string_literal: true

class ::OniSorceress::OuterComm::AtomController < OniSorceress::ApplicationController
  def index
    @articles = ::OniSorceress::Content::Article
      .listable(world: @world)
      .where(last_updated_at: (3.months.ago..))

    newest_article = @articles.first
    @last_updated = newest_article ? newest_article.last_updated_at : Time.zone.local(1970, 1, 1)

    respond_to do |format|
      format.atom { render }
    end
  end
end

app/controllers/oni_sorceress/outer_comm/robots_txt_controller.rb
# frozen_string_literal: true

class ::OniSorceress::OuterComm::RobotsTxtController < OniSorceress::ApplicationController
  layout false

  def show
  end
end

app/controllers/oni_sorceress/outer_comm/sitemap_xml_controller.rb
# frozen_string_literal: true

class ::OniSorceress::OuterComm::SitemapXmlController < OniSorceress::ApplicationController
  layout false

  def show
    @first_level_categories = ::OniSorceress::Content::Category.in_world_first_level(@world)
    @categories = ::OniSorceress::Content::Category.in_world(@world)
    @articles = ::OniSorceress::Content::Article.listable(world: @world)
  end
end

app/views/oni_sorceress/outer_comm/atom/index.atom.erb
<?xml version="1.0" encoding="utf-8"?>
<feed xmlns="http://www.w3.org/2005/Atom">
  <link rel="self" type="application/atom+xml" href="<%= allfeed_atom_url %>" />

  <id><%= url_for('') %>:all</id>
  <title type="text"><%= ENV['META_TITLE_SUFFIX'] %> All</title>
  <subtitle type="text"><%= ENV['META_DESCRIPTION'] %></subtitle>
  <updated><%= @last_updated.iso8601 %></updated>
  <generator uri="https://repo.or.cz/oni_sorceress.git" version="1.0">oni sorceress</generator>
  <rights>See respective licenses in the content</rights>

  <% @articles.each do |article| %>
    <entry>
      <link rel="alternate" type="text/html" href="<%= article_url(id: article.pretty_id) %>" />
      <id><%= article.id %></id>
      <title><%= article.title %></title>
      <updated><%= article.last_updated_at.iso8601 %></updated>
      <published><%= article.posted_at.iso8601 %></published>
      <author>
        <name><%= article.author.name %></name>
      </author>

      <content type="text/html">
        <![CDATA[
          <html>
            <body>
              <h1><%= article.title %></h1>
              <div>
                Author: <%= article.author.name %><br>
                Posted or last updated: <%= article.updated_at.strftime("%d. %b '%y") %><br>
                <%= link_to 'See full article', article_url(id: article.pretty_id) %>
              </div>
              <!-- TODO: this is not shown at all -->
              <div><%= raw render_article(article) %></div>
            </body>
          </html>
        ]]>
      </content>

    </entry>
  <% end %>
</feed>